﻿------------------------------------------------------------------------------------------
--Combo Point-----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local CP = SN:GetModule("classResources")

local GetShapeshiftFormID = GetShapeshiftFormID
local GetComboPoints = GetComboPoints
local MAX_COMBO_POINTS = MAX_COMBO_POINTS
local CAT_FORM = CAT_FORM
local unpack = unpack
local collectgarbage = collectgarbage

function CP:SetupCombo()
	local frame = F.classpower
	local color = M.classResources.ROGUE

	frame.points = CP:PowerBubbles(MAX_COMBO_POINTS)
	for i = 1, MAX_COMBO_POINTS do
		frame.points[i]:SetStatusBarColor(unpack(color[i]))
	end
	frame.points:SetScript("OnEvent", function(self, event, ...)
		if event == "UNIT_COMBO_POINTS" then
			local cpoints = GetComboPoints("player", "target")
			if cpoints > 0 then
				for i = 1, cpoints do
					self[i]:SetAlpha(1)
				end
			else
				for i = 1, MAX_COMBO_POINTS do
					self[i]:SetAlpha(0.1)
				end
			end
		elseif event == "PLAYER_TARGET_CHANGED" then
			local cpoints = GetComboPoints("player", "target")
			if cpoints > 0 then
				for i = 1, cpoints do
					self[i]:SetAlpha(1)
				end
			else
				for i = 1, MAX_COMBO_POINTS do
					self[i]:SetAlpha(0.1)
				end
			end
		end

		if event == "UPDATE_SHAPESHIFT_FORM" then
			local form = GetShapeshiftFormID()
			if SN.playerClass == "DRUID" then
				if form == CAT_FORM then
					CP:ComboEnable()
				else
					CP:ComboDisable()
				end
			end
		end
	end)
	frame.points:Hide()
end

function CP:ComboEnable()
	local frame = F.classpower
	local form = GetShapeshiftFormID()
	if SN.playerClass == "DRUID" then
		if form == CAT_FORM then
			frame.points:Show()
		else
			frame.points:Hide()
		end
	else
		frame.points:Show()
	end
	frame.points:RegisterEvent("UNIT_COMBO_POINTS")
	frame.points:RegisterEvent("PLAYER_TARGET_CHANGED")
	frame.points:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
	local cpoints = GetComboPoints("player", "target")

	if cpoints > 0 then
		for i = 1, cpoints do
			frame.points[i]:SetAlpha(1)
		end
	else
		for i = 1, MAX_COMBO_POINTS do
			frame.points[i]:SetAlpha(0.1)
		end
	end
	ComboFrame:Hide()
	ComboFrame:UnregisterAllEvents()
	collectgarbage("collect")
end

function CP:ComboDisable()
	
	local frame = F.classpower
	frame.points:UnregisterEvent("UNIT_COMBO_POINTS")
	frame.points:UnregisterEvent("PLAYER_TARGET_CHANGED")
	frame.points:Hide()
	ComboFrame:Show()
	ComboFrame:GetScript("OnLoad")(ComboFrame)
	collectgarbage("collect")
end